Package org.apache.wiki.references

## Interface ReferenceManager

All Superinterfaces:
  `java.util.EventListener`, `InternalModule`, `PageFilter`, `WikiEventListener`

All Known Implementing Classes:
  `DefaultReferenceManager`

    public interface ReferenceManager
    extends PageFilter, InternalModule, WikiEventListener

Keeps track of wikipage references:

- What pages a given page refers to
- What pages refer to a given page

When a page is added or edited, its references are parsed, a Collection is received, and we crudely replace anything previous with this new Collection. We then check each referenced page name and make sure they know they are referred to by the new page.

Based on this information, we can perform non-optimal searches for e.g. unreferenced pages, top ten lists, etc.

The owning class must take responsibility of filling in any pre-existing information, probably by loading each and every WikiPage and calling this class to update the references when created.

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `clearPageEntries​(java.lang.String pagename)` Clears the references to a certain page so it's no longer in the map.
`java.util.Set<java.lang.String>` `findCreated()` Returns a list of all pages that the ReferenceManager knows about.
`java.util.Set<java.lang.String>` `findReferredBy​(java.lang.String pageName)` Returns all pages that refer to this page.
`java.util.Set<java.lang.String>` `findReferrers​(java.lang.String pagename)` Find all pages that refer to this page.
`java.util.Collection<java.lang.String>` `findRefersTo​(java.lang.String pageName)` Returns all pages that this page refers to.
`java.util.Collection<java.lang.String>` `findUncreated()` Finds all references to non-existant pages.
`java.util.Collection<java.lang.String>` `findUnreferenced()` Finds all unreferenced pages.
`void` `initialize​(java.util.Collection<Page> pages)` Initializes the entire reference manager with the initial set of pages from the collection.
`void` `pageRemoved​(Page page)` Updates the m_referedTo and m_referredBy hashmaps when a page has been deleted.
`java.util.Collection<java.lang.String>` `scanWikiLinks​(Page page, java.lang.String pagedata)` Reads a WikiPageful of data from a String and returns all links internal to this Wiki in a Collection.
`void` `updateReferences​(java.lang.String page, java.util.Collection<java.lang.String> references)` Updates the referred pages of a new or edited WikiPage.
`void` `updateReferences​(Page page)` Updates all references for the given page.

### Methods inherited from interface org.apache.wiki.api.filters.PageFilter

`destroy, initialize, postSave, postTranslate, preSave, preTranslate`

### Methods inherited from interface org.apache.wiki.event.WikiEventListener

`actionPerformed`

### Method Detail

#### initialize

    void initialize​(java.util.Collection<Page> pages)
             throws ProviderException

Initializes the entire reference manager with the initial set of pages from the collection.

Parameters:
  `pages` - A collection of all pages you want to be included in the reference count.
Throws:
  `ProviderException` - If reading of pages fails.
Since:
  2.2

#### scanWikiLinks

    java.util.Collection<java.lang.String> scanWikiLinks​(Page page,
                                                         java.lang.String pagedata)

Reads a WikiPageful of data from a String and returns all links internal to this Wiki in a Collection.

Parameters:
  `page` - The WikiPage to scan
  `pagedata` - The page contents
Returns:
  a Collection of Strings

#### pageRemoved

    void pageRemoved​(Page page)

Updates the m_referedTo and m_referredBy hashmaps when a page has been deleted.

Within the m_refersTo map the pagename is a key. The whole key-value-set has to be removed to keep the map clean. Within the m_referredBy map the name is stored as a value. Since a key can have more than one value we have to delete just the key-value-pair referring page:deleted page.

Parameters:
  `page` - Name of the page to remove from the maps.

#### updateReferences

    void updateReferences​(Page page)

Updates all references for the given page.

Parameters:
  `page` - wiki page for which references should be updated

#### updateReferences

    void updateReferences​(java.lang.String page,
                          java.util.Collection<java.lang.String> references)

Updates the referred pages of a new or edited WikiPage. If a refersTo entry for this page already exists, it is removed and a new one is built from scratch. Also calls updateReferredBy() for each referenced page.

This is the method to call when a new page has been created and we want to a) set up its references and b) notify the referred pages of the references. Use this method during run-time.

Parameters:
  `page` - Name of the page to update.
  `references` - A Collection of Strings, each one pointing to a page this page references.

#### clearPageEntries

    void clearPageEntries​(java.lang.String pagename)

Clears the references to a certain page so it's no longer in the map.

Parameters:
  `pagename` - Name of the page to clear references for.

#### findUnreferenced

    java.util.Collection<java.lang.String> findUnreferenced()

Finds all unreferenced pages. This requires a linear scan through m_referredBy to locate keys with null or empty values.

Returns:
  The Collection of Strings

#### findUncreated

    java.util.Collection<java.lang.String> findUncreated()

Finds all references to non-existant pages. This requires a linear scan through m_refersTo values; each value must have a corresponding key entry in the reference Maps, otherwise such a page has never been created.

Returns a Collection containing Strings of unreferenced page names. Each non-existant page name is shown only once - we don't return information on who referred to it.

Returns:
  A Collection of Strings

#### findReferrers

    java.util.Set<java.lang.String> findReferrers​(java.lang.String pagename)

Find all pages that refer to this page. Returns null if the page does not exist or is not referenced at all, otherwise returns a collection containing page names (String) that refer to this one.

Parameters:
  `pagename` - The page to find referrers for.
Returns:
  A Set of Strings. May return null, if the page does not exist, or if it has no references.

#### findReferredBy

    java.util.Set<java.lang.String> findReferredBy​(java.lang.String pageName)

Returns all pages that refer to this page. Note that this method returns an unmodifiable Map, which may be abruptly changed. So any access to any iterator may result in a ConcurrentModificationException.

The advantages of using this method over findReferrers() is that it is very fast, as it does not create a new object. The disadvantages are that it does not do any mapping between plural names, and you may end up getting a ConcurrentModificationException.

Parameters:
  `pageName` - Page name to query.
Returns:
  A Set of Strings containing the names of all the pages that refer to this page. May return null, if the page does not exist or has not been indexed yet.
Since:
  2.2.33

#### findRefersTo

    java.util.Collection<java.lang.String> findRefersTo​(java.lang.String pageName)

Returns all pages that this page refers to. You can use this as a quick way of getting the links from a page, but note that it does not link any InterWiki, image, or external links. It does contain attachments, though.

The Collection returned is unmutable, so you cannot change it. It does reflect the current status and thus is a live object. So, if you are using any kind of an iterator on it, be prepared for ConcurrentModificationExceptions.

The returned value is a Collection, because a page may refer to another page multiple times.

Parameters:
  `pageName` - Page name to query
Returns:
  A Collection of Strings containing the names of the pages that this page refers to. May return null, if the page does not exist or has not been indexed yet.
Since:
  2.2.33

#### findCreated

    java.util.Set<java.lang.String> findCreated()

Returns a list of all pages that the ReferenceManager knows about. This should be roughly equivalent to PageManager.getAllPages(), but without the potential disk access overhead. Note that this method is not guaranteed to return a Set of really all pages (especially during startup), but it is very fast.

Returns:
  A Set of all defined page names that ReferenceManager knows about.
Since:
  2.3.24